<?php

declare(strict_types=1);

namespace Smtm\Base\Infrastructure\Helper;

/**
 * @author Milen Dzhambazov <savemetenminutes@gmail.com>
 *
 * Source: https://www.ascii-code.com/
 */
class AsciiHelper
{
    public const CHARACTERS_PRINTABLE =
        ' !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~';
    public const TABLE = [
        [
            'decimal' => '0',
            'octal' => '000',
            'hex' => '00',
            'binary' => '00000000',
            'symbol' => 'NUL',
            'htmlNum' => '&#00;',
            'htmlEntity' => ' ',
            'description' => 'Null character',
        ],
        [
            'decimal' => '1',
            'octal' => '001',
            'hex' => '01',
            'binary' => '00000001',
            'symbol' => 'SOH',
            'htmlNum' => '&#01;',
            'htmlEntity' => ' ',
            'description' => 'Start of Heading',
        ],
        [
            'decimal' => '2',
            'octal' => '002',
            'hex' => '02',
            'binary' => '00000010',
            'symbol' => 'STX',
            'htmlNum' => '&#02;',
            'htmlEntity' => ' ',
            'description' => 'Start of Text',
        ],
        [
            'decimal' => '3',
            'octal' => '003',
            'hex' => '03',
            'binary' => '00000011',
            'symbol' => 'ETX',
            'htmlNum' => '&#03;',
            'htmlEntity' => ' ',
            'description' => 'End of Text',
        ],
        [
            'decimal' => '4',
            'octal' => '004',
            'hex' => '04',
            'binary' => '00000100',
            'symbol' => 'EOT',
            'htmlNum' => '&#04;',
            'htmlEntity' => ' ',
            'description' => 'End of Transmission',
        ],
        [
            'decimal' => '5',
            'octal' => '005',
            'hex' => '05',
            'binary' => '00000101',
            'symbol' => 'ENQ',
            'htmlNum' => '&#05;',
            'htmlEntity' => ' ',
            'description' => 'Enquiry',
        ],
        [
            'decimal' => '6',
            'octal' => '006',
            'hex' => '06',
            'binary' => '00000110',
            'symbol' => 'ACK',
            'htmlNum' => '&#06;',
            'htmlEntity' => ' ',
            'description' => 'Acknowledge',
        ],
        [
            'decimal' => '7',
            'octal' => '007',
            'hex' => '07',
            'binary' => '00000111',
            'symbol' => 'BEL',
            'htmlNum' => '&#07;',
            'htmlEntity' => ' ',
            'description' => 'Bell, Alert',
        ],
        [
            'decimal' => '8',
            'octal' => '010',
            'hex' => '08',
            'binary' => '00001000',
            'symbol' => 'BS',
            'htmlNum' => '&#08;',
            'htmlEntity' => ' ',
            'description' => 'Backspace',
        ],
        [
            'decimal' => '9',
            'octal' => '011',
            'hex' => '09',
            'binary' => '00001001',
            'symbol' => 'HT',
            'htmlNum' => '&#09;',
            'htmlEntity' => ' ',
            'description' => 'Horizontal Tab',
        ],
        [
            'decimal' => '10',
            'octal' => '012',
            'hex' => '0A',
            'binary' => '00001010',
            'symbol' => 'LF',
            'htmlNum' => '&#10;',
            'htmlEntity' => ' ',
            'description' => 'Line Feed',
        ],
        [
            'decimal' => '11',
            'octal' => '013',
            'hex' => '0B',
            'binary' => '00001011',
            'symbol' => 'VT',
            'htmlNum' => '&#11;',
            'htmlEntity' => ' ',
            'description' => 'Vertical Tabulation',
        ],
        [
            'decimal' => '12',
            'octal' => '014',
            'hex' => '0C',
            'binary' => '00001100',
            'symbol' => 'FF',
            'htmlNum' => '&#12;',
            'htmlEntity' => ' ',
            'description' => 'Form Feed',
        ],
        [
            'decimal' => '13',
            'octal' => '015',
            'hex' => '0D',
            'binary' => '00001101',
            'symbol' => 'CR',
            'htmlNum' => '&#13;',
            'htmlEntity' => ' ',
            'description' => 'Carriage Return',
        ],
        [
            'decimal' => '14',
            'octal' => '016',
            'hex' => '0E',
            'binary' => '00001110',
            'symbol' => 'SO',
            'htmlNum' => '&#14;',
            'htmlEntity' => ' ',
            'description' => 'Shift Out',
        ],
        [
            'decimal' => '15',
            'octal' => '017',
            'hex' => '0F',
            'binary' => '00001111',
            'symbol' => 'SI',
            'htmlNum' => '&#15;',
            'htmlEntity' => ' ',
            'description' => 'Shift In',
        ],
        [
            'decimal' => '16',
            'octal' => '020',
            'hex' => '10',
            'binary' => '00010000',
            'symbol' => 'DLE',
            'htmlNum' => '&#16;',
            'htmlEntity' => ' ',
            'description' => 'Data Link Escape',
        ],
        [
            'decimal' => '17',
            'octal' => '021',
            'hex' => '11',
            'binary' => '00010001',
            'symbol' => 'DC1',
            'htmlNum' => '&#17;',
            'htmlEntity' => ' ',
            'description' => 'Device Control One (XON)',
        ],
        [
            'decimal' => '18',
            'octal' => '022',
            'hex' => '12',
            'binary' => '00010010',
            'symbol' => 'DC2',
            'htmlNum' => '&#18;',
            'htmlEntity' => ' ',
            'description' => 'Device Control Two',
        ],
        [
            'decimal' => '19',
            'octal' => '023',
            'hex' => '13',
            'binary' => '00010011',
            'symbol' => 'DC3',
            'htmlNum' => '&#19;',
            'htmlEntity' => ' ',
            'description' => 'Device Control Three (XOFF)',
        ],
        [
            'decimal' => '20',
            'octal' => '024',
            'hex' => '14',
            'binary' => '00010100',
            'symbol' => 'DC4',
            'htmlNum' => '&#20;',
            'htmlEntity' => ' ',
            'description' => 'Device Control Four',
        ],
        [
            'decimal' => '21',
            'octal' => '025',
            'hex' => '15',
            'binary' => '00010101',
            'symbol' => 'NAK',
            'htmlNum' => '&#21;',
            'htmlEntity' => ' ',
            'description' => 'Negative Acknowledge',
        ],
        [
            'decimal' => '22',
            'octal' => '026',
            'hex' => '16',
            'binary' => '00010110',
            'symbol' => 'SYN',
            'htmlNum' => '&#22;',
            'htmlEntity' => ' ',
            'description' => 'Synchronous Idle',
        ],
        [
            'decimal' => '23',
            'octal' => '027',
            'hex' => '17',
            'binary' => '00010111',
            'symbol' => 'ETB',
            'htmlNum' => '&#23;',
            'htmlEntity' => ' ',
            'description' => 'End of Transmission Block',
        ],
        [
            'decimal' => '24',
            'octal' => '030',
            'hex' => '18',
            'binary' => '00011000',
            'symbol' => 'CAN',
            'htmlNum' => '&#24;',
            'htmlEntity' => ' ',
            'description' => 'Cancel',
        ],
        [
            'decimal' => '25',
            'octal' => '031',
            'hex' => '19',
            'binary' => '00011001',
            'symbol' => 'EM',
            'htmlNum' => '&#25;',
            'htmlEntity' => ' ',
            'description' => 'End of medium',
        ],
        [
            'decimal' => '26',
            'octal' => '032',
            'hex' => '1A',
            'binary' => '00011010',
            'symbol' => 'SUB',
            'htmlNum' => '&#26;',
            'htmlEntity' => ' ',
            'description' => 'Substitute',
        ],
        [
            'decimal' => '27',
            'octal' => '033',
            'hex' => '1B',
            'binary' => '00011011',
            'symbol' => 'ESC',
            'htmlNum' => '&#27;',
            'htmlEntity' => ' ',
            'description' => 'Escape',
        ],
        [
            'decimal' => '28',
            'octal' => '034',
            'hex' => '1C',
            'binary' => '00011100',
            'symbol' => 'FS',
            'htmlNum' => '&#28;',
            'htmlEntity' => ' ',
            'description' => 'File Separator',
        ],
        [
            'decimal' => '29',
            'octal' => '035',
            'hex' => '1D',
            'binary' => '00011101',
            'symbol' => 'GS',
            'htmlNum' => '&#29;',
            'htmlEntity' => ' ',
            'description' => 'Group Separator',
        ],
        [
            'decimal' => '30',
            'octal' => '036',
            'hex' => '1E',
            'binary' => '00011110',
            'symbol' => 'RS',
            'htmlNum' => '&#30;',
            'htmlEntity' => ' ',
            'description' => 'Record Separator',
        ],
        [
            'decimal' => '31',
            'octal' => '037',
            'hex' => '1F',
            'binary' => '00011111',
            'symbol' => 'US',
            'htmlNum' => '&#31;',
            'htmlEntity' => ' ',
            'description' => 'Unit Separator',
        ],
        [
            'decimal' => '32',
            'octal' => '040',
            'hex' => '20',
            'binary' => '00100000',
            'symbol' => 'SP',
            'htmlNum' => '&#32;',
            'htmlEntity' => ' ',
            'description' => 'Space',
        ],
        [
            'decimal' => '33',
            'octal' => '041',
            'hex' => '21',
            'binary' => '00100001',
            'symbol' => '!',
            'htmlNum' => '&#33;',
            'htmlEntity' => '&excl;',
            'description' => 'Exclamation mark',
        ],
        [
            'decimal' => '34',
            'octal' => '042',
            'hex' => '22',
            'binary' => '00100010',
            'symbol' => '"',
            'htmlNum' => '&#34;',
            'htmlEntity' => '&quot;',
            'description' => 'Double quotes (or speech marks)',
        ],
        [
            'decimal' => '35',
            'octal' => '043',
            'hex' => '23',
            'binary' => '00100011',
            'symbol' => '#',
            'htmlNum' => '&#35;',
            'htmlEntity' => '&num;',
            'description' => 'Number sign',
        ],
        [
            'decimal' => '36',
            'octal' => '044',
            'hex' => '24',
            'binary' => '00100100',
            'symbol' => '$',
            'htmlNum' => '&#36;',
            'htmlEntity' => '&dollar;',
            'description' => 'Dollar',
        ],
        [
            'decimal' => '37',
            'octal' => '045',
            'hex' => '25',
            'binary' => '00100101',
            'symbol' => '%',
            'htmlNum' => '&#37;',
            'htmlEntity' => '&percnt;',
            'description' => 'Per cent sign',
        ],
        [
            'decimal' => '38',
            'octal' => '046',
            'hex' => '26',
            'binary' => '00100110',
            'symbol' => '&',
            'htmlNum' => '&#38;',
            'htmlEntity' => '&amp;',
            'description' => 'Ampersand',
        ],
        [
            'decimal' => '39',
            'octal' => '047',
            'hex' => '27',
            'binary' => '00100111',
            'symbol' => '\'',
            'htmlNum' => '&#39;',
            'htmlEntity' => '&apos;',
            'description' => 'Single quote',
        ],
        [
            'decimal' => '40',
            'octal' => '050',
            'hex' => '28',
            'binary' => '00101000',
            'symbol' => '(',
            'htmlNum' => '&#40;',
            'htmlEntity' => '&lparen;',
            'description' => 'Open parenthesis (or open bracket)',
        ],
        [
            'decimal' => '41',
            'octal' => '051',
            'hex' => '29',
            'binary' => '00101001',
            'symbol' => ')',
            'htmlNum' => '&#41;',
            'htmlEntity' => '&rparen;',
            'description' => 'Close parenthesis (or close bracket)',
        ],
        [
            'decimal' => '42',
            'octal' => '052',
            'hex' => '2A',
            'binary' => '00101010',
            'symbol' => '*',
            'htmlNum' => '&#42;',
            'htmlEntity' => '&ast;',
            'description' => 'Asterisk',
        ],
        [
            'decimal' => '43',
            'octal' => '053',
            'hex' => '2B',
            'binary' => '00101011',
            'symbol' => '+',
            'htmlNum' => '&#43;',
            'htmlEntity' => '&plus;',
            'description' => 'Plus',
        ],
        [
            'decimal' => '44',
            'octal' => '054',
            'hex' => '2C',
            'binary' => '00101100',
            'symbol' => ',',
            'htmlNum' => '&#44;',
            'htmlEntity' => '&comma;',
            'description' => 'Comma',
        ],
        [
            'decimal' => '45',
            'octal' => '055',
            'hex' => '2D',
            'binary' => '00101101',
            'symbol' => '-',
            'htmlNum' => '&#45;',
            'htmlEntity' => ' ',
            'description' => 'Hyphen-minus',
        ],
        [
            'decimal' => '46',
            'octal' => '056',
            'hex' => '2E',
            'binary' => '00101110',
            'symbol' => '.',
            'htmlNum' => '&#46;',
            'htmlEntity' => '&period;',
            'description' => 'Period, dot or full stop',
        ],
        [
            'decimal' => '47',
            'octal' => '057',
            'hex' => '2F',
            'binary' => '00101111',
            'symbol' => '/',
            'htmlNum' => '&#47;',
            'htmlEntity' => '&sol;',
            'description' => 'Slash or divide',
        ],
        [
            'decimal' => '48',
            'octal' => '060',
            'hex' => '30',
            'binary' => '00110000',
            'symbol' => '0',
            'htmlNum' => '&#48;',
            'htmlEntity' => ' ',
            'description' => 'Zero',
        ],
        [
            'decimal' => '49',
            'octal' => '061',
            'hex' => '31',
            'binary' => '00110001',
            'symbol' => '1',
            'htmlNum' => '&#49;',
            'htmlEntity' => ' ',
            'description' => 'One',
        ],
        [
            'decimal' => '50',
            'octal' => '062',
            'hex' => '32',
            'binary' => '00110010',
            'symbol' => '2',
            'htmlNum' => '&#50;',
            'htmlEntity' => ' ',
            'description' => 'Two',
        ],
        [
            'decimal' => '51',
            'octal' => '063',
            'hex' => '33',
            'binary' => '00110011',
            'symbol' => '3',
            'htmlNum' => '&#51;',
            'htmlEntity' => ' ',
            'description' => 'Three',
        ],
        [
            'decimal' => '52',
            'octal' => '064',
            'hex' => '34',
            'binary' => '00110100',
            'symbol' => '4',
            'htmlNum' => '&#52;',
            'htmlEntity' => ' ',
            'description' => 'Four',
        ],
        [
            'decimal' => '53',
            'octal' => '065',
            'hex' => '35',
            'binary' => '00110101',
            'symbol' => '5',
            'htmlNum' => '&#53;',
            'htmlEntity' => ' ',
            'description' => 'Five',
        ],
        [
            'decimal' => '54',
            'octal' => '066',
            'hex' => '36',
            'binary' => '00110110',
            'symbol' => '6',
            'htmlNum' => '&#54;',
            'htmlEntity' => ' ',
            'description' => 'Six',
        ],
        [
            'decimal' => '55',
            'octal' => '067',
            'hex' => '37',
            'binary' => '00110111',
            'symbol' => '7',
            'htmlNum' => '&#55;',
            'htmlEntity' => ' ',
            'description' => 'Seven',
        ],
        [
            'decimal' => '56',
            'octal' => '070',
            'hex' => '38',
            'binary' => '00111000',
            'symbol' => '8',
            'htmlNum' => '&#56;',
            'htmlEntity' => ' ',
            'description' => 'Eight',
        ],
        [
            'decimal' => '57',
            'octal' => '071',
            'hex' => '39',
            'binary' => '00111001',
            'symbol' => '9',
            'htmlNum' => '&#57;',
            'htmlEntity' => ' ',
            'description' => 'Nine',
        ],
        [
            'decimal' => '58',
            'octal' => '072',
            'hex' => '3A',
            'binary' => '00111010',
            'symbol' => ':',
            'htmlNum' => '&#58;',
            'htmlEntity' => '&colon;',
            'description' => 'Colon',
        ],
        [
            'decimal' => '59',
            'octal' => '073',
            'hex' => '3B',
            'binary' => '00111011',
            'symbol' => ';',
            'htmlNum' => '&#59;',
            'htmlEntity' => '&semi;',
            'description' => 'Semicolon',
        ],
        [
            'decimal' => '60',
            'octal' => '074',
            'hex' => '3C',
            'binary' => '00111100',
            'symbol' => '<',
            'htmlNum' => '&#60;',
            'htmlEntity' => '&lt;',
            'description' => 'Less than (or open angled bracket)',
        ],
        [
            'decimal' => '61',
            'octal' => '075',
            'hex' => '3D',
            'binary' => '00111101',
            'symbol' => '=',
            'htmlNum' => '&#61;',
            'htmlEntity' => '&equals;',
            'description' => 'Equals',
        ],
        [
            'decimal' => '62',
            'octal' => '076',
            'hex' => '3E',
            'binary' => '00111110',
            'symbol' => '>',
            'htmlNum' => '&#62;',
            'htmlEntity' => '&gt;',
            'description' => 'Greater than (or close angled bracket)',
        ],
        [
            'decimal' => '63',
            'octal' => '077',
            'hex' => '3F',
            'binary' => '00111111',
            'symbol' => '?',
            'htmlNum' => '&#63;',
            'htmlEntity' => '&quest;',
            'description' => 'Question mark',
        ],
        [
            'decimal' => '64',
            'octal' => '100',
            'hex' => '40',
            'binary' => '01000000',
            'symbol' => '@',
            'htmlNum' => '&#64;',
            'htmlEntity' => '&commat;',
            'description' => 'At sign',
        ],
        [
            'decimal' => '65',
            'octal' => '101',
            'hex' => '41',
            'binary' => '01000001',
            'symbol' => 'A',
            'htmlNum' => '&#65;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase A',
        ],
        [
            'decimal' => '66',
            'octal' => '102',
            'hex' => '42',
            'binary' => '01000010',
            'symbol' => 'B',
            'htmlNum' => '&#66;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase B',
        ],
        [
            'decimal' => '67',
            'octal' => '103',
            'hex' => '43',
            'binary' => '01000011',
            'symbol' => 'C',
            'htmlNum' => '&#67;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase C',
        ],
        [
            'decimal' => '68',
            'octal' => '104',
            'hex' => '44',
            'binary' => '01000100',
            'symbol' => 'D',
            'htmlNum' => '&#68;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase D',
        ],
        [
            'decimal' => '69',
            'octal' => '105',
            'hex' => '45',
            'binary' => '01000101',
            'symbol' => 'E',
            'htmlNum' => '&#69;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase E',
        ],
        [
            'decimal' => '70',
            'octal' => '106',
            'hex' => '46',
            'binary' => '01000110',
            'symbol' => 'F',
            'htmlNum' => '&#70;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase F',
        ],
        [
            'decimal' => '71',
            'octal' => '107',
            'hex' => '47',
            'binary' => '01000111',
            'symbol' => 'G',
            'htmlNum' => '&#71;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase G',
        ],
        [
            'decimal' => '72',
            'octal' => '110',
            'hex' => '48',
            'binary' => '01001000',
            'symbol' => 'H',
            'htmlNum' => '&#72;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase H',
        ],
        [
            'decimal' => '73',
            'octal' => '111',
            'hex' => '49',
            'binary' => '01001001',
            'symbol' => 'I',
            'htmlNum' => '&#73;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase I',
        ],
        [
            'decimal' => '74',
            'octal' => '112',
            'hex' => '4A',
            'binary' => '01001010',
            'symbol' => 'J',
            'htmlNum' => '&#74;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase J',
        ],
        [
            'decimal' => '75',
            'octal' => '113',
            'hex' => '4B',
            'binary' => '01001011',
            'symbol' => 'K',
            'htmlNum' => '&#75;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase K',
        ],
        [
            'decimal' => '76',
            'octal' => '114',
            'hex' => '4C',
            'binary' => '01001100',
            'symbol' => 'L',
            'htmlNum' => '&#76;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase L',
        ],
        [
            'decimal' => '77',
            'octal' => '115',
            'hex' => '4D',
            'binary' => '01001101',
            'symbol' => 'M',
            'htmlNum' => '&#77;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase M',
        ],
        [
            'decimal' => '78',
            'octal' => '116',
            'hex' => '4E',
            'binary' => '01001110',
            'symbol' => 'N',
            'htmlNum' => '&#78;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase N',
        ],
        [
            'decimal' => '79',
            'octal' => '117',
            'hex' => '4F',
            'binary' => '01001111',
            'symbol' => 'O',
            'htmlNum' => '&#79;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase O',
        ],
        [
            'decimal' => '80',
            'octal' => '120',
            'hex' => '50',
            'binary' => '01010000',
            'symbol' => 'P',
            'htmlNum' => '&#80;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase P',
        ],
        [
            'decimal' => '81',
            'octal' => '121',
            'hex' => '51',
            'binary' => '01010001',
            'symbol' => 'Q',
            'htmlNum' => '&#81;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase Q',
        ],
        [
            'decimal' => '82',
            'octal' => '122',
            'hex' => '52',
            'binary' => '01010010',
            'symbol' => 'R',
            'htmlNum' => '&#82;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase R',
        ],
        [
            'decimal' => '83',
            'octal' => '123',
            'hex' => '53',
            'binary' => '01010011',
            'symbol' => 'S',
            'htmlNum' => '&#83;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase S',
        ],
        [
            'decimal' => '84',
            'octal' => '124',
            'hex' => '54',
            'binary' => '01010100',
            'symbol' => 'T',
            'htmlNum' => '&#84;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase T',
        ],
        [
            'decimal' => '85',
            'octal' => '125',
            'hex' => '55',
            'binary' => '01010101',
            'symbol' => 'U',
            'htmlNum' => '&#85;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase U',
        ],
        [
            'decimal' => '86',
            'octal' => '126',
            'hex' => '56',
            'binary' => '01010110',
            'symbol' => 'V',
            'htmlNum' => '&#86;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase V',
        ],
        [
            'decimal' => '87',
            'octal' => '127',
            'hex' => '57',
            'binary' => '01010111',
            'symbol' => 'W',
            'htmlNum' => '&#87;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase W',
        ],
        [
            'decimal' => '88',
            'octal' => '130',
            'hex' => '58',
            'binary' => '01011000',
            'symbol' => 'X',
            'htmlNum' => '&#88;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase X',
        ],
        [
            'decimal' => '89',
            'octal' => '131',
            'hex' => '59',
            'binary' => '01011001',
            'symbol' => 'Y',
            'htmlNum' => '&#89;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase Y',
        ],
        [
            'decimal' => '90',
            'octal' => '132',
            'hex' => '5A',
            'binary' => '01011010',
            'symbol' => 'Z',
            'htmlNum' => '&#90;',
            'htmlEntity' => ' ',
            'description' => 'Uppercase Z',
        ],
        [
            'decimal' => '91',
            'octal' => '133',
            'hex' => '5B',
            'binary' => '01011011',
            'symbol' => '[',
            'htmlNum' => '&#91;',
            'htmlEntity' => '&lsqb;',
            'description' => 'Opening bracket',
        ],
        [
            'decimal' => '92',
            'octal' => '134',
            'hex' => '5C',
            'binary' => '01011100',
            'symbol' => '\\',
            'htmlNum' => '&#92;',
            'htmlEntity' => '&bsol;',
            'description' => 'Backslash',
        ],
        [
            'decimal' => '93',
            'octal' => '135',
            'hex' => '5D',
            'binary' => '01011101',
            'symbol' => ']',
            'htmlNum' => '&#93;',
            'htmlEntity' => '&rsqb;',
            'description' => 'Closing bracket',
        ],
        [
            'decimal' => '94',
            'octal' => '136',
            'hex' => '5E',
            'binary' => '01011110',
            'symbol' => '^',
            'htmlNum' => '&#94;',
            'htmlEntity' => '&Hat;',
            'description' => 'Caret - circumflex',
        ],
        [
            'decimal' => '95',
            'octal' => '137',
            'hex' => '5F',
            'binary' => '01011111',
            'symbol' => '_',
            'htmlNum' => '&#95;',
            'htmlEntity' => '&lowbar;',
            'description' => 'Underscore',
        ],
        [
            'decimal' => '96',
            'octal' => '140',
            'hex' => '60',
            'binary' => '01100000',
            'symbol' => '`',
            'htmlNum' => '&#96;',
            'htmlEntity' => '&grave;',
            'description' => 'Grave accent',
        ],
        [
            'decimal' => '97',
            'octal' => '141',
            'hex' => '61',
            'binary' => '01100001',
            'symbol' => 'a',
            'htmlNum' => '&#97;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase a',
        ],
        [
            'decimal' => '98',
            'octal' => '142',
            'hex' => '62',
            'binary' => '01100010',
            'symbol' => 'b',
            'htmlNum' => '&#98;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase b',
        ],
        [
            'decimal' => '99',
            'octal' => '143',
            'hex' => '63',
            'binary' => '01100011',
            'symbol' => 'c',
            'htmlNum' => '&#99;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase c',
        ],
        [
            'decimal' => '100',
            'octal' => '144',
            'hex' => '64',
            'binary' => '01100100',
            'symbol' => 'd',
            'htmlNum' => '&#100;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase d',
        ],
        [
            'decimal' => '101',
            'octal' => '145',
            'hex' => '65',
            'binary' => '01100101',
            'symbol' => 'e',
            'htmlNum' => '&#101;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase e',
        ],
        [
            'decimal' => '102',
            'octal' => '146',
            'hex' => '66',
            'binary' => '01100110',
            'symbol' => 'f',
            'htmlNum' => '&#102;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase f',
        ],
        [
            'decimal' => '103',
            'octal' => '147',
            'hex' => '67',
            'binary' => '01100111',
            'symbol' => 'g',
            'htmlNum' => '&#103;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase g',
        ],
        [
            'decimal' => '104',
            'octal' => '150',
            'hex' => '68',
            'binary' => '01101000',
            'symbol' => 'h',
            'htmlNum' => '&#104;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase h',
        ],
        [
            'decimal' => '105',
            'octal' => '151',
            'hex' => '69',
            'binary' => '01101001',
            'symbol' => 'i',
            'htmlNum' => '&#105;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase i',
        ],
        [
            'decimal' => '106',
            'octal' => '152',
            'hex' => '6A',
            'binary' => '01101010',
            'symbol' => 'j',
            'htmlNum' => '&#106;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase j',
        ],
        [
            'decimal' => '107',
            'octal' => '153',
            'hex' => '6B',
            'binary' => '01101011',
            'symbol' => 'k',
            'htmlNum' => '&#107;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase k',
        ],
        [
            'decimal' => '108',
            'octal' => '154',
            'hex' => '6C',
            'binary' => '01101100',
            'symbol' => 'l',
            'htmlNum' => '&#108;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase l',
        ],
        [
            'decimal' => '109',
            'octal' => '155',
            'hex' => '6D',
            'binary' => '01101101',
            'symbol' => 'm',
            'htmlNum' => '&#109;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase m',
        ],
        [
            'decimal' => '110',
            'octal' => '156',
            'hex' => '6E',
            'binary' => '01101110',
            'symbol' => 'n',
            'htmlNum' => '&#110;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase n',
        ],
        [
            'decimal' => '111',
            'octal' => '157',
            'hex' => '6F',
            'binary' => '01101111',
            'symbol' => 'o',
            'htmlNum' => '&#111;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase o',
        ],
        [
            'decimal' => '112',
            'octal' => '160',
            'hex' => '70',
            'binary' => '01110000',
            'symbol' => 'p',
            'htmlNum' => '&#112;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase p',
        ],
        [
            'decimal' => '113',
            'octal' => '161',
            'hex' => '71',
            'binary' => '01110001',
            'symbol' => 'q',
            'htmlNum' => '&#113;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase q',
        ],
        [
            'decimal' => '114',
            'octal' => '162',
            'hex' => '72',
            'binary' => '01110010',
            'symbol' => 'r',
            'htmlNum' => '&#114;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase r',
        ],
        [
            'decimal' => '115',
            'octal' => '163',
            'hex' => '73',
            'binary' => '01110011',
            'symbol' => 's',
            'htmlNum' => '&#115;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase s',
        ],
        [
            'decimal' => '116',
            'octal' => '164',
            'hex' => '74',
            'binary' => '01110100',
            'symbol' => 't',
            'htmlNum' => '&#116;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase t',
        ],
        [
            'decimal' => '117',
            'octal' => '165',
            'hex' => '75',
            'binary' => '01110101',
            'symbol' => 'u',
            'htmlNum' => '&#117;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase u',
        ],
        [
            'decimal' => '118',
            'octal' => '166',
            'hex' => '76',
            'binary' => '01110110',
            'symbol' => 'v',
            'htmlNum' => '&#118;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase v',
        ],
        [
            'decimal' => '119',
            'octal' => '167',
            'hex' => '77',
            'binary' => '01110111',
            'symbol' => 'w',
            'htmlNum' => '&#119;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase w',
        ],
        [
            'decimal' => '120',
            'octal' => '170',
            'hex' => '78',
            'binary' => '01111000',
            'symbol' => 'x',
            'htmlNum' => '&#120;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase x',
        ],
        [
            'decimal' => '121',
            'octal' => '171',
            'hex' => '79',
            'binary' => '01111001',
            'symbol' => 'y',
            'htmlNum' => '&#121;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase y',
        ],
        [
            'decimal' => '122',
            'octal' => '172',
            'hex' => '7A',
            'binary' => '01111010',
            'symbol' => 'z',
            'htmlNum' => '&#122;',
            'htmlEntity' => ' ',
            'description' => 'Lowercase z',
        ],
        [
            'decimal' => '123',
            'octal' => '173',
            'hex' => '7B',
            'binary' => '01111011',
            'symbol' => '{',
            'htmlNum' => '&#123;',
            'htmlEntity' => '&lcub;',
            'description' => 'Opening brace',
        ],
        [
            'decimal' => '124',
            'octal' => '174',
            'hex' => '7C',
            'binary' => '01111100',
            'symbol' => '|',
            'htmlNum' => '&#124;',
            'htmlEntity' => '&verbar;',
            'description' => 'Vertical bar',
        ],
        [
            'decimal' => '125',
            'octal' => '175',
            'hex' => '7D',
            'binary' => '01111101',
            'symbol' => '}',
            'htmlNum' => '&#125;',
            'htmlEntity' => '&rcub;',
            'description' => 'Closing brace',
        ],
        [
            'decimal' => '126',
            'octal' => '176',
            'hex' => '7E',
            'binary' => '01111110',
            'symbol' => '~',
            'htmlNum' => '&#126;',
            'htmlEntity' => '&tilde;',
            'description' => 'Equivalency sign - tilde',
        ],
        [
            'decimal' => '127',
            'octal' => '177',
            'hex' => '7F',
            'binary' => '01111111',
            'symbol' => 'DEL',
            'htmlNum' => '&#127;',
            'htmlEntity' => ' ',
            'description' => 'Delete',
        ],
    ];
}
